clear all;

%read input image 
ip= double(imread('flower2.jpg'));
[x y] = size(ip);

% read other images
data = {'flower6.jpg','flower3.jpg','flower5.jpg','flower4.jpg','flower1.jpg'};

n = 5;
for i=1:n
 op(i, :,:) = double(imread(char(data(i))));
end

arr1 = zeros(1,n);
arr2 = zeros(1,n);
arr3 = zeros(1,n);
arr4 = zeros(1,n);

% Pixel based similarity
for k = 1:n
 for i=1:x
   for j=1:y
   arr1(1, k) = arr1(1, k) + (ip(i, j)-op(k,i, j)) * (ip(i, j)-op(k,i, j));
   end
 end
 arr1(1, k) = sqrt(arr1(1, k));
end

% Sort the results
for i=1:n
 [value, index] = min(arr1(1, :));
  %value
  %index
  sort(1,i) = data(index);
  arr1(1,index) = 5000000;
 end
 sort 

% Based on normalized inner products

va = ip(:);
for k = 1:n
vb = op(k, :);
arr2(1, k) = 1 - ((dot(va, vb)) / (norm(va)*norm(vb)));
end

% Sort the results
for i=1:n
 [value, index] = min(arr2(1, :));
  sort(1, i) = data(index);
  arr2(1,index) = 5000000;
 end
 sort 

% Pixel to Pixel based similarity with squared values
for k = 1:n
 for i=1:x
  for j=1:y
   arr4(1, k) = arr4(1, k) + (ip(i, j)-op(k, i, j)) * (ip(i, j)-op(k, i, j));
  end
 end
end

% Sort the results
for i=1:n
 [value, index] = max(arr4(1, :));
  %value
  %index
  sort(1,(n+1)- i) = data(index);
  arr4(1,index) = -5000000;
 end
 sort  
 
% Pixel to Pixel based similarity with absolute values
for k = 1:n
 for i=1:x
   for j=1:y
   arr3(1, k) = arr3(1, k) + abs(ip(i, j)-op(k, i, j));
   end
 end
end

% Sort the results
for i=1:n
 [value, index] = min(arr3(1, :));
 %value
 %index
 sort(1,i) = data(index);
 arr3(1,index) = 5000000;
 end
 sort 

 



